require_dependency 'resource_planner/application_controller'

module ResourcePlanner
  class ResourcesController < ApplicationController

    # GET /resource_planner/user_preferences.json
    def user_preferences
      @user_preferences = {}

      # Initialise all default user preferences, in event that they are not overridden in the 'user_preferences' structure
      @user_preferences[:locale] = 'en'; # e.g. 'en-gb' (navigator.languages might be better)
      @user_preferences[:timezone] = Time.zone.name;
      @user_preferences[:first_day_of_the_week] = 'Sunday';
      @user_preferences[:selected_resource_colour] = 'rgba(0, 0, 0, 0)';
      @user_preferences[:highlighter_bar_colour] = 'Green';
      @user_preferences[:conflict_colour] = 'LightSalmon';
      @user_preferences[:resource_available_colour] = 'White';
      @user_preferences[:resource_unavailable_colour] = 'Gray';

      # Override defaults with values from the 'application'
      get_user_preferences.each do |user_preference|
        user_preference_value = (eval(user_preference[:data_query]) if !user_preference[:data_query].nil? && !user_preference[:data_query].empty?)
        @user_preferences[user_preference[:key]] = user_preference_value
      end

      respond_to do |format|
        format.html # user_preferences.html.erb
        #format.html { render ('user_preferences.html.erb') }
        format.xml  { render :xml => @user_preferences }
        format.json { render 'user_preferences.json.jbuilder' }
        #format.json { render :json => @user_preferences }
      end
    end

    # GET /resource_planner/list.json
    def list
      @resources = {}
      get_resource_models.each do |resource_model|
        resource_model_data = if resource_model[:data_query].nil? || resource_model[:data_query].empty?
                                resource_model[:model].constantize.all
                              else
                                eval(resource_model[:data_query])
                              end

        @resources[resource_model] = resource_model_data
      end

      respond_to do |format|
        format.html # list.html.erb
        #format.html { render ('list.html.erb') }
        format.xml  { render :xml => @resources }
        format.json { render 'list.json.jbuilder' }
        #format.json { render :json => @resources }
      end
    end

    # GET /resource_planner/events.json
    # GET /resource_events.json
    def events
      @resource_models = get_resource_models
      @user_preferences = get_user_preferences
      @events = ::ResourcePlanner::Event.events

      respond_to do |format|
        format.html # events.html.erb
        #format.html { render ('events.html.erb') }
        format.xml  { render :xml => @events }
        format.json { render 'events.json.jbuilder' }
        #format.json { render :json => @events }
      end
    end

    # GET /resource_planner/restrictions.json
    # GET /resource_restrictions.json
    def restrictions
      @resource_models = get_resource_models
      @user_preferences = get_user_preferences
      @events = ::ResourcePlanner::Event.resource_restrictions

      respond_to do |format|
        format.html # events.html.erb
        #format.html { render ('restrictions.html.erb') }
        format.xml  { render :xml => @events }
        format.json { render 'restrictions.json.jbuilder' }
        #format.json { render :json => @events }
      end
    end
  end
end
